/* SequentialList.c generated by valac 0.44.3, the Vala compiler
 * generated from SequentialList.vala, do not modify */

/* Copyright 2017 Go For It! developers
*
* This file is part of Go For It!.
*
* Go For It! is free software: you can redistribute it
* and/or modify it under the terms of version 3 of the
* GNU General Public License as published by the Free Software Foundation.
*
* Go For It! is distributed in the hope that it will be
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
* Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with Go For It!. If not, see http://www.gnu.org/licenses/.
*/

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <gobject/gvaluecollector.h>

#define TYPE_SEQUENTIAL_LIST (sequential_list_get_type ())
#define SEQUENTIAL_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEQUENTIAL_LIST, SequentialList))
#define SEQUENTIAL_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEQUENTIAL_LIST, SequentialListClass))
#define IS_SEQUENTIAL_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEQUENTIAL_LIST))
#define IS_SEQUENTIAL_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEQUENTIAL_LIST))
#define SEQUENTIAL_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEQUENTIAL_LIST, SequentialListClass))

typedef struct _SequentialList SequentialList;
typedef struct _SequentialListClass SequentialListClass;
typedef struct _SequentialListPrivate SequentialListPrivate;
typedef struct _ParamSpecSequentialList ParamSpecSequentialList;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SequentialList {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SequentialListPrivate * priv;
};

struct _SequentialListClass {
	GTypeClass parent_class;
	void (*finalize) (SequentialList *self);
};

struct _SequentialListPrivate {
	GQueue* items;
	GList* iter_link;
	gint iter_link_index;
	GType item_type;
};

struct _ParamSpecSequentialList {
	GParamSpec parent_instance;
};

static gint SequentialList_private_offset;
static gpointer sequential_list_parent_class = NULL;

gpointer sequential_list_ref (gpointer instance);
void sequential_list_unref (gpointer instance);
GParamSpec* param_spec_sequential_list (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_sequential_list (GValue* value,
                                gpointer v_object);
void value_take_sequential_list (GValue* value,
                                 gpointer v_object);
gpointer value_get_sequential_list (const GValue* value);
GType sequential_list_get_type (void) G_GNUC_CONST;
static void _g_object_unref0_ (gpointer var);
static inline void _g_queue_free__g_object_unref0_ (GQueue* self);
SequentialList* sequential_list_new (GType item_type);
SequentialList* sequential_list_construct (GType object_type,
                                           GType item_type);
static void sequential_list_move_iter_link_to_index (SequentialList* self,
                                              gint index);
void sequential_list_append_item (SequentialList* self,
                                  GObject* item);
guint sequential_list_remove_item (SequentialList* self,
                                   GObject* item);
void sequential_list_move_item (SequentialList* self,
                                guint old_position,
                                guint new_position);
GObject* sequential_list_get_item (SequentialList* self,
                                   guint position);
GType sequential_list_get_item_type (SequentialList* self);
void sequential_list_clear (SequentialList* self);
guint sequential_list_get_length (SequentialList* self);
static void sequential_list_finalize (SequentialList * obj);

static inline gpointer
sequential_list_get_instance_private (SequentialList* self)
{
	return G_STRUCT_MEMBER_P (self, SequentialList_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 113 "SequentialList.c"
}

static inline void
_g_queue_free__g_object_unref0_ (GQueue* self)
{
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_queue_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 121 "SequentialList.c"
}

SequentialList*
sequential_list_construct (GType object_type,
                           GType item_type)
{
	SequentialList* self = NULL;
	GQueue* _tmp0_;
#line 36 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	self = (SequentialList*) g_type_create_instance (object_type);
#line 37 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	self->priv->item_type = item_type;
#line 38 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp0_ = g_queue_new ();
#line 38 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	(self->priv->items == NULL) ? NULL : (self->priv->items = (_g_queue_free__g_object_unref0_ (self->priv->items), NULL));
#line 38 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	self->priv->items = _tmp0_;
#line 39 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	self->priv->iter_link = NULL;
#line 36 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	return self;
#line 144 "SequentialList.c"
}

SequentialList*
sequential_list_new (GType item_type)
{
#line 36 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	return sequential_list_construct (TYPE_SEQUENTIAL_LIST, item_type);
#line 152 "SequentialList.c"
}

static void
sequential_list_move_iter_link_to_index (SequentialList* self,
                                         gint index)
{
	GList* closest_link = NULL;
	gint distance = 0;
	gint distance_head = 0;
	gint distance_tail = 0;
	GQueue* _tmp0_;
	gint distance_iter = 0;
	GList* _tmp5_;
#line 42 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_if_fail (self != NULL);
#line 45 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	distance_head = index;
#line 46 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp0_ = self->priv->items;
#line 46 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	distance_tail = (index - ((gint) _tmp0_->length)) + 1;
#line 49 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if ((-distance_tail) < distance_head) {
#line 176 "SequentialList.c"
		GQueue* _tmp1_;
		GList* _tmp2_;
#line 50 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp1_ = self->priv->items;
#line 50 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp2_ = _tmp1_->tail;
#line 50 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		closest_link = _tmp2_;
#line 51 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		distance = distance_tail;
#line 187 "SequentialList.c"
	} else {
		GQueue* _tmp3_;
		GList* _tmp4_;
#line 53 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp3_ = self->priv->items;
#line 53 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp4_ = _tmp3_->head;
#line 53 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		closest_link = _tmp4_;
#line 54 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		distance = distance_head;
#line 199 "SequentialList.c"
	}
#line 56 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp5_ = self->priv->iter_link;
#line 56 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (_tmp5_ != NULL) {
#line 57 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		distance_iter = index - self->priv->iter_link_index;
#line 58 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		if (abs (distance) > abs (distance_iter)) {
#line 209 "SequentialList.c"
			GList* _tmp6_;
#line 59 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
			distance = distance_iter;
#line 60 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
			_tmp6_ = self->priv->iter_link;
#line 60 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
			closest_link = _tmp6_;
#line 217 "SequentialList.c"
		}
	}
#line 64 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (distance > 0) {
#line 222 "SequentialList.c"
		GList* _tmp7_;
		GList* _tmp8_;
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp7_ = closest_link;
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp8_ = g_list_nth (_tmp7_, (guint) distance);
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		self->priv->iter_link = _tmp8_;
#line 231 "SequentialList.c"
	} else {
		GList* _tmp9_;
		GList* _tmp10_;
#line 67 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp9_ = closest_link;
#line 67 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp10_ = g_list_nth_prev (_tmp9_, (guint) abs (distance));
#line 67 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		self->priv->iter_link = _tmp10_;
#line 241 "SequentialList.c"
	}
#line 69 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	self->priv->iter_link_index = index;
#line 245 "SequentialList.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 74 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	return self ? g_object_ref (self) : NULL;
#line 253 "SequentialList.c"
}

void
sequential_list_append_item (SequentialList* self,
                             GObject* item)
{
	GQueue* _tmp0_;
	GObject* _tmp1_;
#line 72 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_if_fail (self != NULL);
#line 72 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_if_fail (item != NULL);
#line 73 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	self->priv->iter_link = NULL;
#line 74 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp0_ = self->priv->items;
#line 74 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp1_ = _g_object_ref0 (item);
#line 74 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_queue_push_tail (_tmp0_, _tmp1_);
#line 274 "SequentialList.c"
}

guint
sequential_list_remove_item (SequentialList* self,
                             GObject* item)
{
	guint result = 0U;
	guint i = 0U;
	GList* iter = NULL;
	GQueue* _tmp0_;
	GList* _tmp1_;
	GList* _tmp9_;
	GQueue* _tmp10_;
	GList* _tmp11_;
#line 77 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 77 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_val_if_fail (item != NULL, 0U);
#line 78 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	self->priv->iter_link = NULL;
#line 79 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	i = (guint) 0;
#line 80 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp0_ = self->priv->items;
#line 80 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp1_ = _tmp0_->head;
#line 80 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	iter = _tmp1_;
#line 81 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	while (TRUE) {
#line 305 "SequentialList.c"
		gboolean _tmp2_ = FALSE;
		GList* _tmp3_;
		GList* _tmp6_;
		GList* _tmp7_;
		guint _tmp8_;
#line 81 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp3_ = iter;
#line 81 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		if (_tmp3_ != NULL) {
#line 315 "SequentialList.c"
			GList* _tmp4_;
			gconstpointer _tmp5_;
#line 81 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
			_tmp4_ = iter;
#line 81 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
			_tmp5_ = _tmp4_->data;
#line 81 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
			_tmp2_ = ((GObject*) _tmp5_) != item;
#line 324 "SequentialList.c"
		} else {
#line 81 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
			_tmp2_ = FALSE;
#line 328 "SequentialList.c"
		}
#line 81 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		if (!_tmp2_) {
#line 81 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
			break;
#line 334 "SequentialList.c"
		}
#line 82 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp6_ = iter;
#line 82 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp7_ = _tmp6_->next;
#line 82 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		iter = _tmp7_;
#line 83 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp8_ = i;
#line 83 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		i = _tmp8_ + 1;
#line 346 "SequentialList.c"
	}
#line 85 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp9_ = iter;
#line 85 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_vala_assert (_tmp9_ != NULL, "iter != null");
#line 86 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp10_ = self->priv->items;
#line 86 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp11_ = iter;
#line 86 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_queue_delete_link (_tmp10_, _tmp11_);
#line 87 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	result = i;
#line 87 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	return result;
#line 362 "SequentialList.c"
}

void
sequential_list_move_item (SequentialList* self,
                           guint old_position,
                           guint new_position)
{
	gboolean _tmp0_ = FALSE;
	GQueue* _tmp1_;
	GQueue* _tmp2_;
	gpointer _tmp3_;
#line 90 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_if_fail (self != NULL);
#line 91 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (((gint) old_position) >= 0) {
#line 91 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp0_ = ((gint) new_position) >= 0;
#line 380 "SequentialList.c"
	} else {
#line 91 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp0_ = FALSE;
#line 384 "SequentialList.c"
	}
#line 91 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_vala_assert (_tmp0_, "((int)old_position) >= 0 && ((int)new_position) >= 0");
#line 92 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	self->priv->iter_link = NULL;
#line 93 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp1_ = self->priv->items;
#line 93 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp2_ = self->priv->items;
#line 93 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp3_ = g_queue_pop_nth (_tmp2_, old_position);
#line 93 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_queue_push_nth (_tmp1_, (GObject*) _tmp3_, (gint) new_position);
#line 398 "SequentialList.c"
}

GObject*
sequential_list_get_item (SequentialList* self,
                          guint position)
{
	GObject* result = NULL;
	GQueue* _tmp0_;
#line 96 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 97 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_vala_assert (((gint) position) >= 0, "((int)position) >= 0");
#line 98 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp0_ = self->priv->items;
#line 98 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (position < _tmp0_->length) {
#line 415 "SequentialList.c"
		GList* _tmp1_;
		gconstpointer _tmp2_;
		GObject* _tmp3_;
#line 99 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		sequential_list_move_iter_link_to_index (self, (gint) position);
#line 100 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp1_ = self->priv->iter_link;
#line 100 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp2_ = _tmp1_->data;
#line 100 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		_tmp3_ = _g_object_ref0 ((GObject*) _tmp2_);
#line 100 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		result = _tmp3_;
#line 100 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		return result;
#line 431 "SequentialList.c"
	}
#line 102 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	result = NULL;
#line 102 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	return result;
#line 437 "SequentialList.c"
}

GType
sequential_list_get_item_type (SequentialList* self)
{
	GType result = 0UL;
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_val_if_fail (self != NULL, 0UL);
#line 106 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	result = self->priv->item_type;
#line 106 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	return result;
#line 450 "SequentialList.c"
}

void
sequential_list_clear (SequentialList* self)
{
	GQueue* _tmp0_;
#line 109 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_if_fail (self != NULL);
#line 110 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	self->priv->iter_link = NULL;
#line 111 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp0_ = self->priv->items;
#line 111 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_queue_clear (_tmp0_);
#line 465 "SequentialList.c"
}

guint
sequential_list_get_length (SequentialList* self)
{
	guint result;
	GQueue* _tmp0_;
#line 31 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 32 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	_tmp0_ = self->priv->items;
#line 32 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	result = _tmp0_->length;
#line 32 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	return result;
#line 481 "SequentialList.c"
}

static void
value_sequential_list_init (GValue* value)
{
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	value->data[0].v_pointer = NULL;
#line 489 "SequentialList.c"
}

static void
value_sequential_list_free_value (GValue* value)
{
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (value->data[0].v_pointer) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		sequential_list_unref (value->data[0].v_pointer);
#line 499 "SequentialList.c"
	}
}

static void
value_sequential_list_copy_value (const GValue* src_value,
                                  GValue* dest_value)
{
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (src_value->data[0].v_pointer) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		dest_value->data[0].v_pointer = sequential_list_ref (src_value->data[0].v_pointer);
#line 511 "SequentialList.c"
	} else {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		dest_value->data[0].v_pointer = NULL;
#line 515 "SequentialList.c"
	}
}

static gpointer
value_sequential_list_peek_pointer (const GValue* value)
{
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	return value->data[0].v_pointer;
#line 524 "SequentialList.c"
}

static gchar*
value_sequential_list_collect_value (GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (collect_values[0].v_pointer) {
#line 535 "SequentialList.c"
		SequentialList * object;
		object = collect_values[0].v_pointer;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		if (object->parent_instance.g_class == NULL) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 542 "SequentialList.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 546 "SequentialList.c"
		}
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		value->data[0].v_pointer = sequential_list_ref (object);
#line 550 "SequentialList.c"
	} else {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		value->data[0].v_pointer = NULL;
#line 554 "SequentialList.c"
	}
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	return NULL;
#line 558 "SequentialList.c"
}

static gchar*
value_sequential_list_lcopy_value (const GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
	SequentialList ** object_p;
	object_p = collect_values[0].v_pointer;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (!object_p) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 573 "SequentialList.c"
	}
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (!value->data[0].v_pointer) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		*object_p = NULL;
#line 579 "SequentialList.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		*object_p = value->data[0].v_pointer;
#line 583 "SequentialList.c"
	} else {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		*object_p = sequential_list_ref (value->data[0].v_pointer);
#line 587 "SequentialList.c"
	}
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	return NULL;
#line 591 "SequentialList.c"
}

GParamSpec*
param_spec_sequential_list (const gchar* name,
                            const gchar* nick,
                            const gchar* blurb,
                            GType object_type,
                            GParamFlags flags)
{
	ParamSpecSequentialList* spec;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SEQUENTIAL_LIST), NULL);
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	return G_PARAM_SPEC (spec);
#line 610 "SequentialList.c"
}

gpointer
value_get_sequential_list (const GValue* value)
{
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SEQUENTIAL_LIST), NULL);
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	return value->data[0].v_pointer;
#line 620 "SequentialList.c"
}

void
value_set_sequential_list (GValue* value,
                           gpointer v_object)
{
	SequentialList * old;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SEQUENTIAL_LIST));
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	old = value->data[0].v_pointer;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (v_object) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SEQUENTIAL_LIST));
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		value->data[0].v_pointer = v_object;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		sequential_list_ref (value->data[0].v_pointer);
#line 642 "SequentialList.c"
	} else {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		value->data[0].v_pointer = NULL;
#line 646 "SequentialList.c"
	}
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (old) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		sequential_list_unref (old);
#line 652 "SequentialList.c"
	}
}

void
value_take_sequential_list (GValue* value,
                            gpointer v_object)
{
	SequentialList * old;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SEQUENTIAL_LIST));
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	old = value->data[0].v_pointer;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (v_object) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SEQUENTIAL_LIST));
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		value->data[0].v_pointer = v_object;
#line 673 "SequentialList.c"
	} else {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		value->data[0].v_pointer = NULL;
#line 677 "SequentialList.c"
	}
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (old) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		sequential_list_unref (old);
#line 683 "SequentialList.c"
	}
}

static void
sequential_list_class_init (SequentialListClass * klass,
                            gpointer klass_data)
{
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	sequential_list_parent_class = g_type_class_peek_parent (klass);
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	((SequentialListClass *) klass)->finalize = sequential_list_finalize;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_type_class_adjust_private_offset (klass, &SequentialList_private_offset);
#line 697 "SequentialList.c"
}

static void
sequential_list_instance_init (SequentialList * self,
                               gpointer klass)
{
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	self->priv = sequential_list_get_instance_private (self);
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	self->ref_count = 1;
#line 708 "SequentialList.c"
}

static void
sequential_list_finalize (SequentialList * obj)
{
	SequentialList * self;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SEQUENTIAL_LIST, SequentialList);
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_signal_handlers_destroy (self);
#line 25 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	(self->priv->items == NULL) ? NULL : (self->priv->items = (_g_queue_free__g_object_unref0_ (self->priv->items), NULL));
#line 721 "SequentialList.c"
}

/**
 * Data structure used to implement DragListModel.
 * It keeps track of the last accessed link to provide sequential access in O(1).
 * This class doesn't use generics as valac (0.36.7) generated invalid c code 
 * for the code responsible for freeing the internal Queue.
 */
GType
sequential_list_get_type (void)
{
	static volatile gsize sequential_list_type_id__volatile = 0;
	if (g_once_init_enter (&sequential_list_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_sequential_list_init, value_sequential_list_free_value, value_sequential_list_copy_value, value_sequential_list_peek_pointer, "p", value_sequential_list_collect_value, "p", value_sequential_list_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SequentialListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sequential_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SequentialList), 0, (GInstanceInitFunc) sequential_list_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType sequential_list_type_id;
		sequential_list_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SequentialList", &g_define_type_info, &g_define_type_fundamental_info, 0);
		SequentialList_private_offset = g_type_add_instance_private (sequential_list_type_id, sizeof (SequentialListPrivate));
		g_once_init_leave (&sequential_list_type_id__volatile, sequential_list_type_id);
	}
	return sequential_list_type_id__volatile;
}

gpointer
sequential_list_ref (gpointer instance)
{
	SequentialList * self;
	self = instance;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	g_atomic_int_inc (&self->ref_count);
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	return instance;
#line 755 "SequentialList.c"
}

void
sequential_list_unref (gpointer instance)
{
	SequentialList * self;
	self = instance;
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		SEQUENTIAL_LIST_GET_CLASS (self)->finalize (self);
#line 24 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/SequentialList.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 769 "SequentialList.c"
	}
}

