/* Utils.c generated by valac 0.44.3, the Vala compiler
 * generated from Utils.vala, do not modify */

/* Copyright 2014-2017 Go For It! developers
*
* This file is part of Go For It!.
*
* Go For It! is free software: you can redistribute it
* and/or modify it under the terms of version 3 of the
* GNU General Public License as published by the Free Software Foundation.
*
* Go For It! is distributed in the hope that it will be
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
* Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with Go For It!. If not, see http://www.gnu.org/licenses/.
*/

#include <glib-object.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <gobject/gvaluecollector.h>

typedef enum  {
	GOFI_FEATURE_STATUS_UNKNOWN,
	GOFI_FEATURE_STATUS_ALWAYS,
	GOFI_FEATURE_STATUS_COMMON,
	GOFI_FEATURE_STATUS_UNCOMMON,
	GOFI_FEATURE_STATUS_NEVER
} GOFIFeatureStatus;

#define GOFI_TYPE_FEATURE_STATUS (gofi_feature_status_get_type ())

#define GOFI_TYPE_UTILS (gofi_utils_get_type ())
#define GOFI_UTILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GOFI_TYPE_UTILS, GOFIUtils))
#define GOFI_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GOFI_TYPE_UTILS, GOFIUtilsClass))
#define GOFI_IS_UTILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GOFI_TYPE_UTILS))
#define GOFI_IS_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GOFI_TYPE_UTILS))
#define GOFI_UTILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GOFI_TYPE_UTILS, GOFIUtilsClass))

typedef struct _GOFIUtils GOFIUtils;
typedef struct _GOFIUtilsClass GOFIUtilsClass;
typedef struct _GOFIUtilsPrivate GOFIUtilsPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _GOFIParamSpecUtils GOFIParamSpecUtils;

struct _GOFIUtils {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GOFIUtilsPrivate * priv;
};

struct _GOFIUtilsClass {
	GTypeClass parent_class;
	void (*finalize) (GOFIUtils *self);
};

struct _GOFIParamSpecUtils {
	GParamSpec parent_instance;
};

static gpointer gofi_utils_parent_class = NULL;

GType gofi_feature_status_get_type (void) G_GNUC_CONST;
gboolean gofi_feature_status_use_feature (GOFIFeatureStatus self,
                                          gboolean _default);
gboolean gofi_feature_status_config_useful (GOFIFeatureStatus self);
gpointer gofi_utils_ref (gpointer instance);
void gofi_utils_unref (gpointer instance);
GParamSpec* gofi_param_spec_utils (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void gofi_value_set_utils (GValue* value,
                           gpointer v_object);
void gofi_value_take_utils (GValue* value,
                            gpointer v_object);
gpointer gofi_value_get_utils (const GValue* value);
GType gofi_utils_get_type (void) G_GNUC_CONST;
GtkImage* gofi_utils_load_image_fallback (GtkIconSize size,
                                          const gchar* icon_name,
                                          ...);
GOFIUtils* gofi_utils_new (void);
GOFIUtils* gofi_utils_construct (GType object_type);
gchar* gofi_utils_get_config_dir (void);
#define GOFI_APP_SYSTEM_NAME "go-for-it"
gchar* gofi_utils_get_config_file (void);
#define GOFI_FILE_CONF "go-for-it.conf"
gchar* gofi_utils_get_old_config_file (void);
GOFIFeatureStatus gofi_utils_get_desktop_hb_status (void);
static void gofi_utils_finalize (GOFIUtils * obj);

gboolean
gofi_feature_status_use_feature (GOFIFeatureStatus self,
                                 gboolean _default)
{
	gboolean result = FALSE;
#line 36 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	switch (self) {
#line 36 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		case GOFI_FEATURE_STATUS_ALWAYS:
#line 110 "Utils.c"
		{
#line 38 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			result = TRUE;
#line 38 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			return result;
#line 116 "Utils.c"
		}
#line 36 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		case GOFI_FEATURE_STATUS_COMMON:
#line 120 "Utils.c"
		{
#line 40 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			result = TRUE;
#line 40 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			return result;
#line 126 "Utils.c"
		}
#line 36 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		case GOFI_FEATURE_STATUS_UNCOMMON:
#line 130 "Utils.c"
		{
#line 42 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			result = FALSE;
#line 42 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			return result;
#line 136 "Utils.c"
		}
#line 36 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		case GOFI_FEATURE_STATUS_NEVER:
#line 140 "Utils.c"
		{
#line 44 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			result = FALSE;
#line 44 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			return result;
#line 146 "Utils.c"
		}
		default:
		{
#line 46 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			result = _default;
#line 46 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			return result;
#line 154 "Utils.c"
		}
	}
}

gboolean
gofi_feature_status_config_useful (GOFIFeatureStatus self)
{
	gboolean result = FALSE;
#line 51 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	switch (self) {
#line 51 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		case GOFI_FEATURE_STATUS_ALWAYS:
#line 167 "Utils.c"
		{
#line 53 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			result = FALSE;
#line 53 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			return result;
#line 173 "Utils.c"
		}
#line 51 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		case GOFI_FEATURE_STATUS_NEVER:
#line 177 "Utils.c"
		{
#line 55 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			result = FALSE;
#line 55 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			return result;
#line 183 "Utils.c"
		}
		default:
		{
#line 57 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			result = TRUE;
#line 57 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			return result;
#line 191 "Utils.c"
		}
	}
}

/**
     * Used to pass information about if a feature is standard on the desktop 
     * of the user.
     */
GType
gofi_feature_status_get_type (void)
{
	static volatile gsize gofi_feature_status_type_id__volatile = 0;
	if (g_once_init_enter (&gofi_feature_status_type_id__volatile)) {
		static const GEnumValue values[] = {{GOFI_FEATURE_STATUS_UNKNOWN, "GOFI_FEATURE_STATUS_UNKNOWN", "unknown"}, {GOFI_FEATURE_STATUS_ALWAYS, "GOFI_FEATURE_STATUS_ALWAYS", "always"}, {GOFI_FEATURE_STATUS_COMMON, "GOFI_FEATURE_STATUS_COMMON", "common"}, {GOFI_FEATURE_STATUS_UNCOMMON, "GOFI_FEATURE_STATUS_UNCOMMON", "uncommon"}, {GOFI_FEATURE_STATUS_NEVER, "GOFI_FEATURE_STATUS_NEVER", "never"}, {0, NULL, NULL}};
		GType gofi_feature_status_type_id;
		gofi_feature_status_type_id = g_enum_register_static ("GOFIFeatureStatus", values);
		g_once_init_leave (&gofi_feature_status_type_id__volatile, gofi_feature_status_type_id);
	}
	return gofi_feature_status_type_id__volatile;
}

/**
         * Loads the first icon in the list, which is contained in the
         * active icon theme. This way one can avoid the "broken image" icon
         * by offering a list of fallback icon names.
         */
GtkImage*
gofi_utils_load_image_fallback (GtkIconSize size,
                                const gchar* icon_name,
                                ...)
{
	GtkImage* result = NULL;
	GtkImage* _result_ = NULL;
	GtkImage* _tmp0_;
	GtkIconTheme* _tmp1_;
	va_list fallbacks = {0};
#line 137 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 139 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name (icon_name, (GtkIconSize) size);
#line 139 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	g_object_ref_sink (_tmp0_);
#line 139 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	_result_ = _tmp0_;
#line 141 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	_tmp1_ = gtk_icon_theme_get_default ();
#line 141 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	if (gtk_icon_theme_has_icon (_tmp1_, icon_name)) {
#line 142 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		result = _result_;
#line 142 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		return result;
#line 244 "Utils.c"
	}
#line 146 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	va_start (fallbacks, icon_name);
#line 147 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	while (TRUE) {
#line 250 "Utils.c"
		gchar* fallback_name = NULL;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		GtkIconTheme* _tmp5_;
		const gchar* _tmp6_;
#line 148 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		_tmp2_ = va_arg (fallbacks, gchar*);
#line 148 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 148 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		fallback_name = _tmp3_;
#line 149 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		_tmp4_ = fallback_name;
#line 149 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		if (_tmp4_ == NULL) {
#line 152 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			result = _result_;
#line 152 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			_g_free0 (fallback_name);
#line 152 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			va_end (fallbacks);
#line 152 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			return result;
#line 275 "Utils.c"
		}
#line 156 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		_tmp5_ = gtk_icon_theme_get_default ();
#line 156 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		_tmp6_ = fallback_name;
#line 156 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		if (gtk_icon_theme_has_icon (_tmp5_, _tmp6_)) {
#line 283 "Utils.c"
			const gchar* _tmp7_;
			GtkImage* _tmp8_;
#line 157 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			_tmp7_ = fallback_name;
#line 157 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			_tmp8_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp7_, (GtkIconSize) size);
#line 157 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			g_object_ref_sink (_tmp8_);
#line 157 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			result = _tmp8_;
#line 157 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			_g_free0 (fallback_name);
#line 157 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			va_end (fallbacks);
#line 157 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			_g_object_unref0 (_result_);
#line 157 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			return result;
#line 302 "Utils.c"
		}
#line 147 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		_g_free0 (fallback_name);
#line 306 "Utils.c"
	}
#line 137 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	va_end (fallbacks);
#line 137 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	_g_object_unref0 (_result_);
#line 312 "Utils.c"
}

GOFIUtils*
gofi_utils_construct (GType object_type)
{
	GOFIUtils* self = NULL;
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	self = (GOFIUtils*) g_type_create_instance (object_type);
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	return self;
#line 323 "Utils.c"
}

GOFIUtils*
gofi_utils_new (void)
{
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	return gofi_utils_construct (GOFI_TYPE_UTILS);
#line 331 "Utils.c"
}

gchar*
gofi_utils_get_config_dir (void)
{
	gchar* result;
	gchar* user_config_dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 72 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	_tmp0_ = g_get_user_config_dir ();
#line 72 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 72 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	user_config_dir = _tmp1_;
#line 73 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	_tmp2_ = g_build_filename (user_config_dir, GOFI_APP_SYSTEM_NAME, NULL);
#line 73 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	result = _tmp2_;
#line 73 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	_g_free0 (user_config_dir);
#line 73 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	return result;
#line 356 "Utils.c"
}

gchar*
gofi_utils_get_config_file (void)
{
	gchar* result;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 82 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	_tmp0_ = gofi_utils_get_config_dir ();
#line 82 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	_tmp1_ = _tmp0_;
#line 82 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	_tmp2_ = _tmp1_;
#line 82 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	_tmp3_ = g_build_filename (_tmp2_, GOFI_FILE_CONF, NULL);
#line 82 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	_tmp4_ = _tmp3_;
#line 82 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	_g_free0 (_tmp2_);
#line 82 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	result = _tmp4_;
#line 82 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	return result;
#line 384 "Utils.c"
}

gchar*
gofi_utils_get_old_config_file (void)
{
	gchar* result;
	gchar* user_config_dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 92 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	_tmp0_ = g_get_user_config_dir ();
#line 92 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 92 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	user_config_dir = _tmp1_;
#line 93 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	_tmp2_ = g_build_filename (user_config_dir, GOFI_FILE_CONF, NULL);
#line 93 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	result = _tmp2_;
#line 93 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	_g_free0 (user_config_dir);
#line 93 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	return result;
#line 409 "Utils.c"
}

GOFIFeatureStatus
gofi_utils_get_desktop_hb_status (void)
{
	GOFIFeatureStatus result;
	gchar* desktop = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GQuark _tmp5_ = 0U;
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	static GQuark _tmp4_label0 = 0;
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	static GQuark _tmp4_label1 = 0;
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	static GQuark _tmp4_label2 = 0;
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	static GQuark _tmp4_label3 = 0;
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	static GQuark _tmp4_label4 = 0;
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	static GQuark _tmp4_label5 = 0;
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	static GQuark _tmp4_label6 = 0;
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	static GQuark _tmp4_label7 = 0;
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	static GQuark _tmp4_label8 = 0;
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	static GQuark _tmp4_label9 = 0;
#line 103 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	_tmp0_ = g_getenv ("DESKTOP_SESSION");
#line 103 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 103 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	desktop = _tmp1_;
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	_tmp2_ = desktop;
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	_tmp3_ = _tmp2_;
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	if (_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("pantheon")))) {
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		switch (0) {
#line 458 "Utils.c"
			default:
			{
#line 107 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				result = GOFI_FEATURE_STATUS_ALWAYS;
#line 107 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				_g_free0 (desktop);
#line 107 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				return result;
#line 467 "Utils.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("gnome")))) {
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		switch (0) {
#line 473 "Utils.c"
			default:
			{
#line 109 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				result = GOFI_FEATURE_STATUS_ALWAYS;
#line 109 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				_g_free0 (desktop);
#line 109 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				return result;
#line 482 "Utils.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label2) ? _tmp4_label2 : (_tmp4_label2 = g_quark_from_static_string ("budgie")))) {
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		switch (0) {
#line 488 "Utils.c"
			default:
			{
#line 111 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				result = GOFI_FEATURE_STATUS_ALWAYS;
#line 111 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				_g_free0 (desktop);
#line 111 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				return result;
#line 497 "Utils.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label3) ? _tmp4_label3 : (_tmp4_label3 = g_quark_from_static_string ("ubuntu")))) {
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		switch (0) {
#line 503 "Utils.c"
			default:
			{
#line 113 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				result = GOFI_FEATURE_STATUS_UNCOMMON;
#line 113 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				_g_free0 (desktop);
#line 113 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				return result;
#line 512 "Utils.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label4) ? _tmp4_label4 : (_tmp4_label4 = g_quark_from_static_string ("kde")))) {
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		switch (0) {
#line 518 "Utils.c"
			default:
			{
#line 115 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				result = GOFI_FEATURE_STATUS_UNCOMMON;
#line 115 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				_g_free0 (desktop);
#line 115 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				return result;
#line 527 "Utils.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label5) ? _tmp4_label5 : (_tmp4_label5 = g_quark_from_static_string ("plasma")))) {
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		switch (0) {
#line 533 "Utils.c"
			default:
			{
#line 117 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				result = GOFI_FEATURE_STATUS_UNCOMMON;
#line 117 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				_g_free0 (desktop);
#line 117 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				return result;
#line 542 "Utils.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label6) ? _tmp4_label6 : (_tmp4_label6 = g_quark_from_static_string ("xfce4")))) {
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		switch (0) {
#line 548 "Utils.c"
			default:
			{
#line 119 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				result = GOFI_FEATURE_STATUS_UNCOMMON;
#line 119 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				_g_free0 (desktop);
#line 119 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				return result;
#line 557 "Utils.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label7) ? _tmp4_label7 : (_tmp4_label7 = g_quark_from_static_string ("cinnamon")))) {
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		switch (0) {
#line 563 "Utils.c"
			default:
			{
#line 121 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				result = GOFI_FEATURE_STATUS_UNCOMMON;
#line 121 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				_g_free0 (desktop);
#line 121 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				return result;
#line 572 "Utils.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label8) ? _tmp4_label8 : (_tmp4_label8 = g_quark_from_static_string ("mate")))) {
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		switch (0) {
#line 578 "Utils.c"
			default:
			{
#line 123 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				result = GOFI_FEATURE_STATUS_UNCOMMON;
#line 123 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				_g_free0 (desktop);
#line 123 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				return result;
#line 587 "Utils.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label9) ? _tmp4_label9 : (_tmp4_label9 = g_quark_from_static_string ("")))) {
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		switch (0) {
#line 593 "Utils.c"
			default:
			{
#line 125 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				result = GOFI_FEATURE_STATUS_UNCOMMON;
#line 125 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				_g_free0 (desktop);
#line 125 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				return result;
#line 602 "Utils.c"
			}
		}
	} else {
#line 105 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		switch (0) {
#line 608 "Utils.c"
			default:
			{
#line 127 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				result = GOFI_FEATURE_STATUS_UNKNOWN;
#line 127 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				_g_free0 (desktop);
#line 127 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
				return result;
#line 617 "Utils.c"
			}
		}
	}
#line 102 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	_g_free0 (desktop);
#line 623 "Utils.c"
}

static void
gofi_value_utils_init (GValue* value)
{
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	value->data[0].v_pointer = NULL;
#line 631 "Utils.c"
}

static void
gofi_value_utils_free_value (GValue* value)
{
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	if (value->data[0].v_pointer) {
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		gofi_utils_unref (value->data[0].v_pointer);
#line 641 "Utils.c"
	}
}

static void
gofi_value_utils_copy_value (const GValue* src_value,
                             GValue* dest_value)
{
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	if (src_value->data[0].v_pointer) {
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		dest_value->data[0].v_pointer = gofi_utils_ref (src_value->data[0].v_pointer);
#line 653 "Utils.c"
	} else {
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		dest_value->data[0].v_pointer = NULL;
#line 657 "Utils.c"
	}
}

static gpointer
gofi_value_utils_peek_pointer (const GValue* value)
{
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	return value->data[0].v_pointer;
#line 666 "Utils.c"
}

static gchar*
gofi_value_utils_collect_value (GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	if (collect_values[0].v_pointer) {
#line 677 "Utils.c"
		GOFIUtils * object;
		object = collect_values[0].v_pointer;
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		if (object->parent_instance.g_class == NULL) {
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 684 "Utils.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 688 "Utils.c"
		}
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		value->data[0].v_pointer = gofi_utils_ref (object);
#line 692 "Utils.c"
	} else {
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		value->data[0].v_pointer = NULL;
#line 696 "Utils.c"
	}
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	return NULL;
#line 700 "Utils.c"
}

static gchar*
gofi_value_utils_lcopy_value (const GValue* value,
                              guint n_collect_values,
                              GTypeCValue* collect_values,
                              guint collect_flags)
{
	GOFIUtils ** object_p;
	object_p = collect_values[0].v_pointer;
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	if (!object_p) {
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 715 "Utils.c"
	}
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	if (!value->data[0].v_pointer) {
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		*object_p = NULL;
#line 721 "Utils.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		*object_p = value->data[0].v_pointer;
#line 725 "Utils.c"
	} else {
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		*object_p = gofi_utils_ref (value->data[0].v_pointer);
#line 729 "Utils.c"
	}
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	return NULL;
#line 733 "Utils.c"
}

GParamSpec*
gofi_param_spec_utils (const gchar* name,
                       const gchar* nick,
                       const gchar* blurb,
                       GType object_type,
                       GParamFlags flags)
{
	GOFIParamSpecUtils* spec;
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GOFI_TYPE_UTILS), NULL);
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	return G_PARAM_SPEC (spec);
#line 752 "Utils.c"
}

gpointer
gofi_value_get_utils (const GValue* value)
{
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GOFI_TYPE_UTILS), NULL);
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	return value->data[0].v_pointer;
#line 762 "Utils.c"
}

void
gofi_value_set_utils (GValue* value,
                      gpointer v_object)
{
	GOFIUtils * old;
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GOFI_TYPE_UTILS));
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	old = value->data[0].v_pointer;
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	if (v_object) {
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GOFI_TYPE_UTILS));
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		value->data[0].v_pointer = v_object;
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		gofi_utils_ref (value->data[0].v_pointer);
#line 784 "Utils.c"
	} else {
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		value->data[0].v_pointer = NULL;
#line 788 "Utils.c"
	}
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	if (old) {
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		gofi_utils_unref (old);
#line 794 "Utils.c"
	}
}

void
gofi_value_take_utils (GValue* value,
                       gpointer v_object)
{
	GOFIUtils * old;
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GOFI_TYPE_UTILS));
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	old = value->data[0].v_pointer;
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	if (v_object) {
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GOFI_TYPE_UTILS));
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		value->data[0].v_pointer = v_object;
#line 815 "Utils.c"
	} else {
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		value->data[0].v_pointer = NULL;
#line 819 "Utils.c"
	}
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	if (old) {
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		gofi_utils_unref (old);
#line 825 "Utils.c"
	}
}

static void
gofi_utils_class_init (GOFIUtilsClass * klass,
                       gpointer klass_data)
{
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	gofi_utils_parent_class = g_type_class_peek_parent (klass);
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	((GOFIUtilsClass *) klass)->finalize = gofi_utils_finalize;
#line 837 "Utils.c"
}

static void
gofi_utils_instance_init (GOFIUtils * self,
                          gpointer klass)
{
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	self->ref_count = 1;
#line 846 "Utils.c"
}

static void
gofi_utils_finalize (GOFIUtils * obj)
{
	GOFIUtils * self;
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GOFI_TYPE_UTILS, GOFIUtils);
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	g_signal_handlers_destroy (self);
#line 857 "Utils.c"
}

/**
     * A collection of static utility functions.
     */
GType
gofi_utils_get_type (void)
{
	static volatile gsize gofi_utils_type_id__volatile = 0;
	if (g_once_init_enter (&gofi_utils_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { gofi_value_utils_init, gofi_value_utils_free_value, gofi_value_utils_copy_value, gofi_value_utils_peek_pointer, "p", gofi_value_utils_collect_value, "p", gofi_value_utils_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GOFIUtilsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gofi_utils_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GOFIUtils), 0, (GInstanceInitFunc) gofi_utils_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType gofi_utils_type_id;
		gofi_utils_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GOFIUtils", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&gofi_utils_type_id__volatile, gofi_utils_type_id);
	}
	return gofi_utils_type_id__volatile;
}

gpointer
gofi_utils_ref (gpointer instance)
{
	GOFIUtils * self;
	self = instance;
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	g_atomic_int_inc (&self->ref_count);
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	return instance;
#line 887 "Utils.c"
}

void
gofi_utils_unref (gpointer instance)
{
	GOFIUtils * self;
	self = instance;
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		GOFI_UTILS_GET_CLASS (self)->finalize (self);
#line 65 "/usr/src/RPM/BUILD/go-for-it-1.6.5/src/Utils.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 901 "Utils.c"
	}
}

